#!/usr/bin/python

import os, sys, socket, time, IPy


mode = 'full'

def ip2host(v6, domain, mode=mode):
    if (v6.find("ip6.arpa") > -1):
        raise Exception, "use reverse2ip() first"

    a = IPy.IP(v6)
    if mode == 'full':
        foo = a.strNormal().replace(":", "-")
        return foo + "." + domain

    # egentlig: '2001:700:300:10c2:20c:6eff:fe33:ef90'
    # v6 = '0.9.f.e.3.3.e.f.f.f.e.6.c.0.2.0.2.c.0.1.0.0.3.0.0.0.7.0.1.0.0.2.ip6.arpa'
#    _z = v6.split(".")
#    _z.reverse()

    # adding 2 to also remove the ip6.arpa -part.
#    _z = _z[networkwords+2:]
#    _x = "".join(_z)

    # standard nonsense ;)
#    _x = _x.replace("arpaip62001070003001", "")
    
    # _x = '10c2020c6efffe33ef90'

    # bah.. how can this possibly go wrong!? ;)
#    _x = _x.replace("fffe","")
#    _x = _x[0:(len(_x) - (6+4))] + _x[(len(_x)-6):len(_x)]

#    return _x + "." + domain

def cleanip(ip, changed_last=1):
    if not changed_last:
        return
    changed = 0
    z = ""
    for j in range(0,len(ip)):
        if ip[j] == "0" and ip[j-1] == ':':
            pass
            changed = 1
        else:
            z += ip[j]

    if changed:
        cleanip(z, changed)
    return z


def host2ip(host, mode=mode):
    host = host.split(".")[0] # hihi

    if mode == 'full':
        a = IPy.IP(host.replace("-", ":"))
        return a.strCompressed()

    # host = 'xxxxyyyyy' with n x-es and always 6 y's.
    # so.

#    host_part = host[0:(l-6)] + "fffe" + host[l-6:l]
#    host_part = host[0:10] + "fffe" + host[10:]

    # as we don't know how many octetts are used, we need
    # to work our way from the back.
#    host_part_formatted = ""
    
#    z = 0
#    for i in range((len(host_part) -1), 0, -1):
#        host_part_formatted = host_part[i] + host_part_formatted
#        z = z + 1
#        if z == 4:
#            host_part_formatted = ":" + host_part_formatted
#            z = 0
#
#    ip = network + host_part_formatted
#    return ip

def reverse2ip(rev):
    """ Takes '0.9.f.e.3.3.e.f.f.f.e.6.c.0.2.0.2.c.0.1.0.0.3.0.0.0.7.0.1.0.0.2.ip6.arpa'
    and returns the encoded ip-address.

    If the string is a subzone, we try to fake it into 2001:700:300::. this
    may be very wrong.
    
    """

    # egentlig: '2001:700:300:10c2:20c:6eff:fe33:ef90'
    # v6 = '0.9.f.e.3.3.e.f.f.f.e.6.c.0.2.0.2.c.0.1.0.0.3.0.0.0.7.0.1.0.0.2.ip6.arpa'
    _z = rev.split(".")
    _z.reverse()

    ip_formatted = ''
    # remove the ip6.arpa -part.
    _z = _z[2:]
    _x = "".join(_z)

    z = 0
    for i in range(0, len(_z)):
        if z == 4:
            ip_formatted += ":"
            z = 0
        z = z + 1
        ip_formatted = ip_formatted + _z[i]
    # hoping for the best .. se comment
    if ip_formatted.count(":") < 7:
        if ip_formatted[-1] == ':':
            ip_formatted += ':'
        else:
            ip_formatted += '::'
     
    return IPy.IP(ip_formatted).strCompressed()



# tests
def test_reverse2ip():
    rev = '0.9.f.e.3.3.e.f.f.f.e.6.c.0.2.0.2.c.0.1.0.0.3.0.0.0.7.0.1.0.0.2.ip6.arpa'
    z = reverse2ip(rev)
    assert rev == IPy.IP(z).reverseName().replace("ip6.int.","ip6.arpa")

    # mongo
    z = '1.0.0.3.0.0.0.7.0.1.0.0.2.ip6.arpa'
    assert reverse2ip(z) == '2001:700:300:1::'

def test_ip2host():
    ips = ["2001:700:300:1::13"]
    for ip in ips:
        host_from_ip = ip2host(ip, 'v6.ntnu.no', mode='full')
        ip_from_host = host2ip(host_from_ip, mode='full')
        assert ip_from_host == ip

def test_host2ip():
    assert host2ip('2001-700-300-1-0-0-0-1.v6.ntnu.no', mode='full') == '2001:700:300:1::1' 


def test_converse():
    ip = "2001:700:300:3::12"
    host_from_ip = ip2host(ip, 'v6.ntnu.no', mode='full')
    ip_from_host = host2ip(host_from_ip, mode='full')
    assert ip_from_host == ip

    

def test():
    test_reverse2ip()
    test_ip2host()
    test_host2ip()
    test_converse()
#    ip1 = '2001:700:300:1::13'
#    ip1_host = ip2host(ip1)
#    ip1_host_ip = host2ip(ip1_host) + " "
#
#    print ip1, ip1_host_ip
#    assert ip1_host_ip == ip1
#
#    ip = '0.9.f.e.3.3.e.f.f.f.e.6.c.0.2.0.2.c.0.1.0.0.3.0.0.0.7.0.1.0.0.2.ip6.arpa'



if __name__ == '__main__':
    test()

